package behaviours;

import java.util.Random;

import message.messageSistem;
import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class registrar extends OneShotBehaviour{

	private static final long serialVersionUID = -8848033140780055772L;	
	
	public registrar(Agent a) {
		super(a);
	}

	public void action() {
		
		myAgent.doWait(new Random().nextInt(1000*10));
		
		DFAgentDescription agent_description = new DFAgentDescription();
		agent_description.setName(myAgent.getAID());
		ServiceDescription agent_service = new ServiceDescription();
		agent_service.setName("invitado");
		agent_service.setType("invitado");
		agent_description.addServices(agent_service);
		try {
			DFService.register(myAgent, agent_description);
		} catch (FIPAException e) {
			e.printStackTrace();
		}
		
		System.out.println("[ '" + myAgent.getLocalName() + "' ::: REGISTRADO ]");
		
		//MSG

		messageSistem.sendToGroup(myAgent, "saludar_todos", "anfitrion");
		messageSistem.sendToGroup(myAgent, "saludar_todos", "invitado");
		
		
		myAgent.addBehaviour(new saludar(myAgent));
		
	}		
}
