package behaviours;

import java.util.Random;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.TickerBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.wrapper.AgentContainer;
import jade.wrapper.AgentController;
import jade.lang.acl.ACLMessage;
import message.messageSistem;

public class servir extends TickerBehaviour{
	
	ACLMessage msg = null;

	public servir(Agent a, long period){
		super(a, period);
	}
			private static final long serialVersionUID = 1L;

			public void onStart(){
				
				msg = myAgent.blockingReceive();
				
				myAgent.doWait(5000);
	      		//System.out.println("[ '"+ myAgent.getLocalName() + "' ::: COMIENZA A SERVIR ]");
			
	      		msg = null;
			}
			
			protected void onTick() {
				
					msg = myAgent.receive();
					
					//Se eliminan los camareros cuando se han satisfecho todos los invitados
					if(msg!=null && msg.getContent()!=null && msg.getContent().equals("terminar"))
						myAgent.doDelete();
					
					myAgent.doWait(new Random().nextInt(1000*20));
					
					// Si Random < 25 se sirve al anfitrion, sino a un invitado
		      		if (new Random().nextInt(100) >= 25){
		      			messageSistem.sendToGroup_Random(myAgent, "servir", "invitado");
		      		}else{
		      			messageSistem.sendToGroup(myAgent, "servir", "anfitrion");
		      		}
		      		
		    		//permitira indicar que camarero a servido
		    		messageSistem.sendToGroup(myAgent, "ha_servido", "anfitrion"); 
	
			}
}
