package behaviours;


import java.util.Random;

import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import message.messageSistem;

public class saludar extends CyclicBehaviour{

	ACLMessage msg = null;
	
	public saludar(Agent a){
		super(a);
	}
	
	public void action() {
		msg = myAgent.receive();
		
		if (msg!= null && msg.getContent() != null )
        {
	        	switch (msg.getContent())
	        	{  		
	        		case "saludar_todos":
		        		System.out.println("\t'"+msg.getSender().getLocalName() + "' - SALUDA A - '" + myAgent.getLocalName()+"'\t\t\t["
		        				+msg.getSender().getLocalName()+" ---> " + myAgent.getLocalName()+"]");
	        			messageSistem.sendTo(myAgent, "saludar_uno", msg.getSender());	        			
	        			break;
	        		
	       			
	        		case "saludar_uno":
		        		System.out.println("\t'"+ msg.getSender().getLocalName() + "' - DEVUELVE SALUDO A -'" + myAgent.getLocalName() +"'\t\t["
		        				+ msg.getSender().getLocalName() +" ---> " + myAgent.getLocalName() +"]");
	        			break;  
	        			
	        		//El anfitrion indica que los invitados pueden empezar a comer
	        		case "ya":
	        			myAgent.addBehaviour(new comer(myAgent,this));
	        			break;
	        	}
        }
	}	

}
